﻿using Infragistics.Win.UltraWinTree;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApplication53
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            DataSet ds = new DataSet();
            DataTable parentTable = ds.Tables.Add("Campaigns");
            parentTable.Columns.Add("Campaign_ID");
            parentTable.Columns.Add("Campaign_Name");
            parentTable.Columns.Add("Status");
            parentTable.Columns.Add("Description");
            parentTable.Columns.Add("Owner_Name");
            parentTable.Columns.Add("Site_Code");
            DataTable childTable = ds.Tables.Add("Experiments");
            childTable.Columns.Add("Experiment_ID");
            childTable.Columns.Add("Experiment_Name");
            childTable.Columns.Add("Status");
            childTable.Columns.Add("Campaign_ID");
            childTable.Columns.Add("Owner_Name");
            childTable.Columns.Add("Experiment_Type");
            ds.Relations.Add("Campaign_Expermints", parentTable.Columns["Campaign_ID"], childTable.Columns["Campaign_ID"]);

            parentTable.Rows.Add(new object[] { 66, "CD33", 0, null, "ASMS", "UP" });
            parentTable.Rows.Add(new object[] { 67, "CD34", 0, null, "ASMS", "UP" });
            parentTable.Rows.Add(new object[] { 68, "CD35", 0, null, "ASMS", "UP" });

            childTable.Rows.Add(new object[] { 1070, "HitID", 1, 66, "ASMS", "HitID" });
            childTable.Rows.Add(new object[] { 1071, "HitID1", 1, 66, "ASMS", "HitID" });
            childTable.Rows.Add(new object[] { 1072, "HitID2", 1, 66, "ASMS", "HitID" });
            childTable.Rows.Add(new object[] { 1073, "HitID3", 1, 66, "ASMS", "HitID" });

            childTable.Rows.Add(new object[] { 1074, "HitID4", 1, 67, "ASMS", "HitID" });
            childTable.Rows.Add(new object[] { 1075, "HitID5", 1, 67, "ASMS", "HitID" });
            childTable.Rows.Add(new object[] { 1076, "HitID6", 1, 67, "ASMS", "HitID" });
            childTable.Rows.Add(new object[] { 1077, "HitID7", 1, 67, "ASMS", "HitID" });

            childTable.Rows.Add(new object[] { 1078, "HitID8", 1, 68, "ASMS", "HitID" });
            childTable.Rows.Add(new object[] { 1079, "HitID9", 1, 68, "ASMS", "HitID" });
            childTable.Rows.Add(new object[] { 1080, "HitID10", 1, 68, "ASMS", "HitID" });
            childTable.Rows.Add(new object[] { 1081, "HitID11", 1, 68, "ASMS", "HitID" });

            this.ultraTree1.SetDataBinding(ds, "Campaigns");
            this.ultraTree1.ViewStyle = Infragistics.Win.UltraWinTree.ViewStyle.OutlookExpress;
            this.ultraTree1.ExpandAll(Infragistics.Win.UltraWinTree.ExpandAllType.Always);
        }

        private void ultraTree1_ColumnSetGenerated(object sender, Infragistics.Win.UltraWinTree.ColumnSetGeneratedEventArgs e)
        {
            switch (e.ColumnSet.Key)
            {
                case "Campaigns":
                    {
                        // Since these fields are showing the values of various bands, change the
                        // caption. 
                        e.ColumnSet.Columns["Campaign_ID"].Text = "ID";
                        e.ColumnSet.Columns["Campaign_Name"].Text = "Name";
                    }
                    break;

                case "Campaign_Expermints":
                    {
                        // Since this is shown in the parent row, you presumably don't want to see
                        // it in the child row. 
                        e.ColumnSet.Columns["Campaign_ID"].Visible = false;

                        e.ColumnSet.Columns["Experiment_ID"].MapToColumn = "Campaign_ID";
                        e.ColumnSet.Columns["Experiment_Name"].MapToColumn = "Campaign_Name";

                        // These two are not strictly neccessary, since the names are already the same. 
                        e.ColumnSet.Columns["Status"].MapToColumn = "Status";
                        e.ColumnSet.Columns["Owner_Name"].MapToColumn = "Owner_Name";

                        // Things get a little weird here, because there is only one column left in 
                        // the child band, but two in the parent band. So there's essentially nothing
                        // under the parent band's Site_Code field. 
                        e.ColumnSet.Columns["Experiment_Type"].MapToColumn = "Description";
                    }

                    break;
            }
        }
    }
}
